registerComponent("Five Star Half", "", "Five Star Half", "Five Star Half control", "five_star_half_init", "", "five_star_half_refresh", "real:value:0:0:5,imagepicker:StarOn:star_on.png,imagepicker:StarOff:star_off.png,imagepicker:StarHalf:star_half.png", "On Release", "", 11,49,88,53);

function five_star_half_init(width, height) {
	//create five stars
	var star1 = createComponent(self, 'image', 0, 0, 20, 100);
	var star2 = createComponent(self, 'image', 20, 0, 40, 100);
	var star3 = createComponent(self, 'image', 40, 0, 60, 100);
	var star4 = createComponent(self, 'image', 60, 0, 80, 100);
	var star5 = createComponent(self, 'image', 80, 0, 100, 100);
		
	//setup default value
	setData(self, "value",0)
	
	//assign star images
	five_star_half_draw()

	//Bind any events to the main component or subcomponents
	bindEvent(self, 'on_up', 'five_star_half_on_up');
}

function five_star_half_refresh(width, height) {
	five_star_half_draw()	
}

function five_star_half_on_up(x, y, tid){
	//work out how many stars to show
	var width = Number(getProperty(self,"width"))
	var value_real = ((x / width) * 10.0) + 1.0
	var value = Math.floor(value_real) / 2.0
	if (value_real<1.3){ 
		//special case for zero on the left third of first star!
		setData(self,"value",0)
	}else{
		setData(self,"value",value)
	}
	five_star_half_draw()
	
	//now raise the event
	raiseEvent(self, 'On Release','{"value":' + value + '}');
}

function five_star_half_draw(){
	var value = Number(getData(self,"value"))
	var stars = []
	for(var i=0;i<5;i++){
		stars[i] = getComponentChild(self, i)
	}
	
	var staron = getData(self,"StarOn")	
	var staroff = getData(self,"StarOff")
	var starhalf = getData(self,"StarHalf")
	
	//assign star images
	for(var i=0;i<5;i++){
		if (value >= i + 1.0){
			setProperty(stars[i],"filename",staron)
		}else if(value >= i + 0.5){
			setProperty(stars[i],"filename",starhalf)
		}else{
			setProperty(stars[i],"filename",staroff)
		}
	}
}

